/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for JobConfiguration.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobConfiguration extends GenericJson {

  /**
   * [Pick one] Copies a table.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobConfigurationTableCopy copy;

  /**
   * [Optional] If set, don't actually run this job. A valid query will return a mostly empty
   * response with some processing statistics, while an invalid query will return the same error it
   * would if it wasn't a dry run. Behavior of non-query jobs is undefined.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean dryRun;

  /**
   * [Pick one] Configures an extract job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobConfigurationExtract extract;

  /**
   * [Pick one] Configures a link job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobConfigurationLink link;

  /**
   * [Pick one] Configures a load job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobConfigurationLoad load;

  /**
   * [Pick one] Configures a query job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobConfigurationQuery query;

  /**
   * [Pick one] Copies a table.
   * The value returned may be {@code null}.
   */
  public JobConfigurationTableCopy getCopy() {
    return copy;
  }

  /**
   * [Pick one] Copies a table.
   * The value set may be {@code null}.
   */
  public JobConfiguration setCopy(JobConfigurationTableCopy copy) {
    this.copy = copy;
    return this;
  }

  /**
   * [Optional] If set, don't actually run this job. A valid query will return a mostly empty
   * response with some processing statistics, while an invalid query will return the same error it
   * would if it wasn't a dry run. Behavior of non-query jobs is undefined.
   * The value returned may be {@code null}.
   */
  public Boolean getDryRun() {
    return dryRun;
  }

  /**
   * [Optional] If set, don't actually run this job. A valid query will return a mostly empty
   * response with some processing statistics, while an invalid query will return the same error it
   * would if it wasn't a dry run. Behavior of non-query jobs is undefined.
   * The value set may be {@code null}.
   */
  public JobConfiguration setDryRun(Boolean dryRun) {
    this.dryRun = dryRun;
    return this;
  }

  /**
   * [Pick one] Configures an extract job.
   * The value returned may be {@code null}.
   */
  public JobConfigurationExtract getExtract() {
    return extract;
  }

  /**
   * [Pick one] Configures an extract job.
   * The value set may be {@code null}.
   */
  public JobConfiguration setExtract(JobConfigurationExtract extract) {
    this.extract = extract;
    return this;
  }

  /**
   * [Pick one] Configures a link job.
   * The value returned may be {@code null}.
   */
  public JobConfigurationLink getLink() {
    return link;
  }

  /**
   * [Pick one] Configures a link job.
   * The value set may be {@code null}.
   */
  public JobConfiguration setLink(JobConfigurationLink link) {
    this.link = link;
    return this;
  }

  /**
   * [Pick one] Configures a load job.
   * The value returned may be {@code null}.
   */
  public JobConfigurationLoad getLoad() {
    return load;
  }

  /**
   * [Pick one] Configures a load job.
   * The value set may be {@code null}.
   */
  public JobConfiguration setLoad(JobConfigurationLoad load) {
    this.load = load;
    return this;
  }

  /**
   * [Pick one] Configures a query job.
   * The value returned may be {@code null}.
   */
  public JobConfigurationQuery getQuery() {
    return query;
  }

  /**
   * [Pick one] Configures a query job.
   * The value set may be {@code null}.
   */
  public JobConfiguration setQuery(JobConfigurationQuery query) {
    this.query = query;
    return this;
  }

}
