/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for JobConfigurationExtract.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobConfigurationExtract extends GenericJson {

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String destinationFormat;

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String destinationUri;

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String fieldDelimiter;

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean printHeader;

  /**
   * [Required] A reference to the table being exported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TableReference sourceTable;

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * The value returned may be {@code null}.
   */
  public String getDestinationFormat() {
    return destinationFormat;
  }

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * The value set may be {@code null}.
   */
  public JobConfigurationExtract setDestinationFormat(String destinationFormat) {
    this.destinationFormat = destinationFormat;
    return this;
  }

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * The value returned may be {@code null}.
   */
  public String getDestinationUri() {
    return destinationUri;
  }

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * The value set may be {@code null}.
   */
  public JobConfigurationExtract setDestinationUri(String destinationUri) {
    this.destinationUri = destinationUri;
    return this;
  }

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * The value returned may be {@code null}.
   */
  public String getFieldDelimiter() {
    return fieldDelimiter;
  }

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * The value set may be {@code null}.
   */
  public JobConfigurationExtract setFieldDelimiter(String fieldDelimiter) {
    this.fieldDelimiter = fieldDelimiter;
    return this;
  }

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * The value returned may be {@code null}.
   */
  public Boolean getPrintHeader() {
    return printHeader;
  }

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * The value set may be {@code null}.
   */
  public JobConfigurationExtract setPrintHeader(Boolean printHeader) {
    this.printHeader = printHeader;
    return this;
  }

  /**
   * [Required] A reference to the table being exported.
   * The value returned may be {@code null}.
   */
  public TableReference getSourceTable() {
    return sourceTable;
  }

  /**
   * [Required] A reference to the table being exported.
   * The value set may be {@code null}.
   */
  public JobConfigurationExtract setSourceTable(TableReference sourceTable) {
    this.sourceTable = sourceTable;
    return this;
  }

}
