/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for JobReference.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobReference extends GenericJson {

  /**
   * [Required] ID of the job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String jobId;

  /**
   * [Required] Project ID being billed for the job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String projectId;

  /**
   * [Required] ID of the job.
   * The value returned may be {@code null}.
   */
  public String getJobId() {
    return jobId;
  }

  /**
   * [Required] ID of the job.
   * The value set may be {@code null}.
   */
  public JobReference setJobId(String jobId) {
    this.jobId = jobId;
    return this;
  }

  /**
   * [Required] Project ID being billed for the job.
   * The value returned may be {@code null}.
   */
  public String getProjectId() {
    return projectId;
  }

  /**
   * [Required] Project ID being billed for the job.
   * The value set may be {@code null}.
   */
  public JobReference setProjectId(String projectId) {
    this.projectId = projectId;
    return this;
  }

}
