/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for JobStatus.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobStatus extends GenericJson {

  /**
   * [Output-only] Final error result of the job. If present, indicates that the job has completed
   * and was unsuccessful.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ErrorProto errorResult;

  /**
   * [Output-only] All errors encountered during the running of the job. Errors here do not
   * necessarily mean that the job has completed or was unsuccessful.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<ErrorProto> errors;

  static {
    // hack to force ProGuard to consider ErrorProto used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(ErrorProto.class);
  }

  /**
   * [Output-only] Running state of the job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String state;

  /**
   * [Output-only] Final error result of the job. If present, indicates that the job has completed
   * and was unsuccessful.
   * The value returned may be {@code null}.
   */
  public ErrorProto getErrorResult() {
    return errorResult;
  }

  /**
   * [Output-only] Final error result of the job. If present, indicates that the job has completed
   * and was unsuccessful.
   * The value set may be {@code null}.
   */
  public JobStatus setErrorResult(ErrorProto errorResult) {
    this.errorResult = errorResult;
    return this;
  }

  /**
   * [Output-only] All errors encountered during the running of the job. Errors here do not
   * necessarily mean that the job has completed or was unsuccessful.
   * The value returned may be {@code null}.
   */
  public java.util.List<ErrorProto> getErrors() {
    return errors;
  }

  /**
   * [Output-only] All errors encountered during the running of the job. Errors here do not
   * necessarily mean that the job has completed or was unsuccessful.
   * The value set may be {@code null}.
   */
  public JobStatus setErrors(java.util.List<ErrorProto> errors) {
    this.errors = errors;
    return this;
  }

  /**
   * [Output-only] Running state of the job.
   * The value returned may be {@code null}.
   */
  public String getState() {
    return state;
  }

  /**
   * [Output-only] Running state of the job.
   * The value set may be {@code null}.
   */
  public JobStatus setState(String state) {
    this.state = state;
    return this;
  }

}
