/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for TableFieldSchema.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TableFieldSchema extends GenericJson {

  /**
   * [Optional] Describes the nested schema fields if the type property is set to RECORD.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<TableFieldSchema> fields;

  static {
    // hack to force ProGuard to consider TableFieldSchema used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(TableFieldSchema.class);
  }

  /**
   * [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default
   * value is NULLABLE.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String mode;

  /**
   * [Required] The field name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * [Required] The field data type. Possible values include STRING, INTEGER, FLOAT, BOOLEAN,
   * TIMESTAMP or RECORD (where RECORD indicates a nested schema).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * [Optional] Describes the nested schema fields if the type property is set to RECORD.
   * The value returned may be {@code null}.
   */
  public java.util.List<TableFieldSchema> getFields() {
    return fields;
  }

  /**
   * [Optional] Describes the nested schema fields if the type property is set to RECORD.
   * The value set may be {@code null}.
   */
  public TableFieldSchema setFields(java.util.List<TableFieldSchema> fields) {
    this.fields = fields;
    return this;
  }

  /**
   * [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default
   * value is NULLABLE.
   * The value returned may be {@code null}.
   */
  public String getMode() {
    return mode;
  }

  /**
   * [Optional] The field mode. Possible values include NULLABLE, REQUIRED and REPEATED. The default
   * value is NULLABLE.
   * The value set may be {@code null}.
   */
  public TableFieldSchema setMode(String mode) {
    this.mode = mode;
    return this;
  }

  /**
   * [Required] The field name.
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * [Required] The field name.
   * The value set may be {@code null}.
   */
  public TableFieldSchema setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * [Required] The field data type. Possible values include STRING, INTEGER, FLOAT, BOOLEAN,
   * TIMESTAMP or RECORD (where RECORD indicates a nested schema).
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * [Required] The field data type. Possible values include STRING, INTEGER, FLOAT, BOOLEAN,
   * TIMESTAMP or RECORD (where RECORD indicates a nested schema).
   * The value set may be {@code null}.
   */
  public TableFieldSchema setType(String type) {
    this.type = type;
    return this;
  }

}
